//
// mixins/general
//
// aspect-ratio()
// box-shadow()
// center-absolute()
// debug()
// invisible()
// make-col()
// make-gutter()
// make-row()
// navigation()
// transition()
// wrapper()
//

// aspect-ratio
@mixin aspect-ratio($width, $height, $element: '*') {
  & {
    position: relative;
  }

  &::before {
    display: block;
    content: '';
    width: 100%;
    padding-top: ($height / $width) * 100%;
  }

  > #{$element} {
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
  }
}

// box-shadow
@mixin box-shadow ($level) {
  @if ($level == 1) {
    box-shadow: 0 1px 3px rgba(black,0.12), 0 1px 2px rgba(black,0.24);
  }
  @elseif ($level == 2) {
    box-shadow: 0 3px 6px rgba(black,0.16), 0 3px 6px rgba(black,0.23);
  }
  @elseif ($level == 3) {
    box-shadow: 0 10px 20px rgba(black,0.19), 0 6px 6px rgba(black,0.23);
  }
  @elseif ($level == 4) {
    box-shadow: 0 14px 28px rgba(black,0.25), 0 10px 10px rgba(black,0.22);
  }
  @elseif ($level == 5) {
    box-shadow: 0 19px 38px rgba(black,0.30), 0 15px 12px rgba(0,0,0,0.22);
  }
}

// center-absolute
@mixin center-absolute($position) {
  position: absolute;

  @if $position == 'vertical' {
    top: 50%;
    transform: translateY(-50%);
  } @else 
  if $position == 'horizontal' {
    left: 50%;
    transform: translateX(-50%);
  } @else 
  if $position == 'both' {
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
}

// debug
@mixin debug($color: $color-debug) {
  outline: 1px solid rgba($color, 0.25);
}

// invisible
@mixin invisible() {
  position: absolute;
  overflow: hidden;
  clip: rect(0 0 0 0);
  height: 1px;
  width: 1px;
  margin: -1px;
  padding: 0 !important;
  border: 0;
}

// make-col
@mixin make-col($size, $columns: $grid-columns) {
  flex: 0 0 percentage($size / $columns);
  max-width: percentage($size / $columns);
}

// make-gutter
@mixin make-gutter() {
  margin-left: calc(#{$base-spacing-unit} / -2);
  margin-right: calc(#{$base-spacing-unit} / -2);

  > * {
    padding-left: calc(#{$base-spacing-unit} / 2);
    padding-right: calc(#{$base-spacing-unit} / 2);
  }
}

// make-row
@mixin make-row() {
  display: flex;
  flex-wrap: wrap;

  > * {
    width: 100%; // [1] Set all child-elements to 100% width as default
  }
}

// navigation
@mixin navigation() {
  ul {
    @extend %list-reset;
  }

  a {
    text-decoration: none;
  }
}

// transition
@mixin transition($element: all) {
  transition: $element 125ms ease-in-out;
}

// wrapper
@mixin wrapper($breakpoint: 'md') {
  width: 100%;
  margin-left: auto;
  margin-right: auto;
  max-width: map-get($breakpoints, $breakpoint);
}

// Functions
// function map-deep-get()
// function to get a value from a nested map, see _type.scss for usage
//
@function map-deep-get($map, $keys...) {
  @each $key in $keys {
    $map: map-get($map, $key);
  }
  @return $map;
}

// function headings()
// function to generate headlines h1 – h6
//
// usage:
// #{headings()} { … } will result in
// h1, h2, … h6 { … }
// ---
// #{headings(2,4) { … } will result in
// h2,h3,h4 { … }
// ---
@function headings($first:1, $last:6) {
  @if $first == $last {
    @return 'h#{$first}';
  } @else {
    @return 'h#{$first},' + headings($first+1, $last);
  }
}
